//core.java Summer 2003 - Winter 2004
//Features:
// TCP stream (send/receive)
// <CR><LF> terminated message handling
// simple-chat protocol 1 (revision 1.4)
// Parses input in the SubSpace chat format (;channel, //team, etc)

import java.io.*;
import java.net.*;
//import java.util.*;

public class core extends Thread {
	static final int version  = 25;
	static final int protocol = 1;

	//Modules
	static loggers    lm;
	static config     cfg;
	static ui         win;
	static data       pd;

	//TCP
	Socket         socket;
	PrintWriter    send;
	BufferedReader recv;

	public int stage;
	final int STAGE_PROFILE = 0;
	final int STAGE_RUNNING = 1;
	final int STAGE_STOPPED = 2;
	final int STAGE_QUIT    = 3;
	
	static    boolean bKeepGoing   = false;
	protected boolean bConnected   = false;
	static    boolean bGotSheep    = true;
	static    boolean bLogFileOpen = true; //Can assume it was openned by chatnet.java

	//User data
	protected String  name         = "*Unknown*";
	static String  pass         = "cane";
	static String  arena        = "0";
	static String  auto         = null;
	protected String  freq         = "8025";

	//Messages
	static int     namelen      = 10;
	static int     showEnterMsg = 1; //0 is status bar
	static int     showLeaveMsg = 1; //1 is chat
	static int     showKillMsg  = 0; //2 is off
	static String  awayMsg      = "";
	static String  lastAwayName = "*Unknown*";

//// Util ////

	//For ?namelen command
	public int StrAToIx(String str)
	{
		int i=0;
		str = str.substring(8);
		lm.Log("D", str);
		try
		{
			i = Integer.parseInt(str);
		}
		catch (Exception e)
		{
			return namelen;
		}

		if (i < 2 || i > 24)
		{
			return namelen;
		} else
		{
			return i;
		}		
	}

	private static String StrPad(String str)
	{
		if (str.length() > namelen)
			return str.substring(0, namelen);
		while(str.length() < namelen) str = " " + str;
		return str;
	}

//// Send ////

	public void sendRaw(String str)
	{
		if (!bConnected) return;
		send.println(str);
		lm.Log("D", "<core> Sending: " + str);
	}

	public void Login()
	{
		//name        = cfg.GetStr("ChatNet", "Name");
		//String pass = cfg.GetStr("ChatNet", "Pass");
		//arena       = cfg.GetStr("ChatNet", "Arena");
		sendRaw("LOGIN:" + protocol + ":" + name + ":" + pass);
	}

	public void Go(String name)
	{
		sendRaw("GO:" + name);
	}

	public void ChangeFreq(String freq)
	{
		sendRaw("CHANGEFREQ:" + freq);
	}

	public void sendPub(String msg)
	{
		sendRaw("SEND:PUB:" + msg);
	}

	public void sendPriv(String name, String msg)
	{
		sendRaw("SEND:PRIV:" + name + ":" + msg);
	}

	public void sendFreq(String freq, String msg)
	{
		sendRaw("SEND:FREQ:" + freq + ":" + msg);
	}

	public void sendChat(String channelnum, String line)
	{
		sendRaw("SEND:CHAT:" + channelnum + ";" + line);
	}

	public void sendMod(String msg)
	{
		sendRaw("SEND:MOD:" + msg);
	}

	public void sendCmd(String cmd)
	{
		sendRaw("SEND:CMD:" + cmd);
	}

	public void sendPrivCmd(String name, String cmd)
	{
		sendRaw("SEND:PRIVCMD:" + name + ":" + cmd);
	}

	public void sendSquad(String squad, String msg)
	{
		sendRaw("SEND:SQUAD:" + squad + ":" + msg);
	}

	public void cmdHandler(String cmd)
	{
		if (cmd == null) return;
		if (cmd.length() < 2) return;
		cmd = cmd.substring(1);
		String msg = cmd.toLowerCase();

		//1 to 24
		if (msg.startsWith("namelen"))
		{
			if (cmd.length() > 8) //8? orig = 9
			{
				if (cmd.charAt(7) == '=' ||
					cmd.charAt(7) == ' ')
				{
					namelen = StrAToIx(cmd);
					win.println("  Message Name " +
						"Length: " + namelen);

				}
			}
		} else
		if (msg.startsWith("ignore"))
		{
			if (cmd.length() > 7) //7? orig=8
			{
				String noob = msg.substring(7, msg.length());
				String[] players = pd.lsPlayer();
				int i;
				
				//Match input with known players
				for(i=0; i<players.length; i++)
				{
					if (players[i].equalsIgnoreCase(noob))
						break;
				}
				if (i < players.length)
				{
					String flags = pd.getFlags(players[i]);
					if (flags == null || flags.indexOf("I") < 0)
					{
						//Ignore player
						pd.setFlags(players[i], flags + "I");
						win.println("  Ignoring: " +
							players[i]);
					}
					else
					{
						//Listen to player
						flags = flags.replaceAll("I",
							"");
						pd.setFlags(players[i], flags);
						win.println("  Listening: " +
							players[i]);
					}
				}
				else
				{
					win.println("  Could not ?ignore '" +
						noob + "'.");
				}
			}
		} else
		if (msg.equals("enter"))
		{
			if (showEnterMsg == 0)
			{
				showEnterMsg = 1;
				win.println("  Enter Messages to chat");
			} else
			if (showEnterMsg == 1)
			{
				showEnterMsg = 2;
				win.println("  Enter Messages OFF");
			} else
			//if (showEnterMsg == 2)
			{
				showEnterMsg = 0;
				win.println("  Enter Messages to status bar");
			}
		} else
		if (msg.equals("leave"))
		{
			if (showLeaveMsg == 0)
			{
				showLeaveMsg = 1;
				win.println("  Leave Messages to chat");
			} else
			if (showLeaveMsg == 1)
			{
				showLeaveMsg = 2;
				win.println("  Leave Messages OFF");
			} else
			//if (showLeaveMsg == 2)
			{
				showLeaveMsg = 0;
				win.println("  Leave Messages to status bar");
			}
		} else
		if (msg.equals("kill"))
		{
			if (showKillMsg == 0)
			{
				showKillMsg = 1;
				win.println("  Kill Messages to chat");
			} else
			if (showKillMsg == 1)
			{
				showKillMsg = 2;
				win.println("  Kill Messages OFF");
			} else
			//if (showKillMsg == 2)
			{
				showKillMsg = 0;
				win.println("  Kill Messages to status bar");
			}
		} else
		if (msg.startsWith("away"))
		{
			if (cmd.length() > 5)
			{
				if (cmd.charAt(4) == '=' ||
					cmd.charAt(4) == ' ')
				{
					awayMsg = cmd.substring(5);
					lastAwayName = "*Unknown*";
					win.println("  Away message " +
						"turned ON");
				}
			} else
			{
				awayMsg = "";
				lastAwayName = "*Unknown*";
				win.println("  Away message turned " +
					"OFF");
			}
		} else
		if (msg.startsWith("go "))
		{
			Go(msg.substring(3));
		} else
		if (msg.equals("go"))
		{
			Go("");
		} else
		if (msg.startsWith("log"))
		{
			if (bLogFileOpen)
			{
				//Close
				lm.CloseChatLog();
				bLogFileOpen = false;
				win.println("  Log file closed");
			}
			else
			{
				//Open
				if (cmd.length() > 4)
				{
					lm.OpenChatLog(cmd.substring(4));
					bLogFileOpen = true;
					win.println("  Log file open: " + cmd.substring(4));
				}
			}
		} else
		if (msg.startsWith("clear"))
		{
			win.clear();
		} else
		if (msg.startsWith("disconnect"))
		{
			if (bConnected)
				disconnect();
			stage = STAGE_STOPPED;
		} else
		if (msg.startsWith("exit"))
		{
			//if (bConnected)
			//	disconnect();
			stage = STAGE_QUIT;
		} else
		{
			win.println(win.BLUE, "  " + StrPad(name) + "> ?" +
				cmd);
			sendCmd("?" + cmd);
		}
	}

	//Due to a nice Asss feature, ?commands can be sent as PUB
	//Good since private commands aren't filtered yet
	public void chatHandler(String str)
	{
		String[] part;
		String channelnum, msg;
		
		//Private (and remote priv)
		if (str.startsWith(":") && str.substring(1).indexOf(":") > 0)
		{
			part = str.substring(1).split(":", 2);
			sendPriv(part[0], part[1]);
			
			if (!pd.existPlayer(part[0]))
			{
				//Remote priv
				win.println(win.GREEN, "P " + str);
				win.addLastPrivPlayer(part[0]);
			}
			else
			{
				//priv
				win.println(win.GREEN, "P " + StrPad(name) +
					"> " + part[1]);
			}
		} else
		//Channels
		if (str.startsWith(";"))
		{
			if (str.length() > 2 && str.charAt(2) == ';')
			{
				channelnum = "" + str.charAt(1);
				msg = str.substring(3);
			} else
			{
				channelnum = "1";
				msg = str.substring(1);
			}
			if (msg.length() > 0)
			{
				sendChat(channelnum, msg);
				win.println(win.ORANGE, "C " + channelnum + ":" + name +
					"> " + msg);
			}
		} else
		//Team
		if (str.startsWith("//"))
		{
			//Don't send "//" to pub chat
			if (str.length() > 2)
			{
				msg = str.substring(2);
				sendFreq(freq, msg);
				win.println(win.YELLOW, "T " + StrPad(name) +
					"> " + msg);
			}
		} else
		//Team (again)
		if (str.startsWith("\""))
		{
			String to = win.getSelectedName();
			if (to == null) return;
			String tofreq = pd.getFreq(to);
		
			//Don't send " to pub chat
			if (str.length() > 1)
			{
				msg = str.substring(1);
				sendFreq(tofreq, msg);
				
				win.println(win.GREEN, "E " + StrPad(name) +
					"> ", win.BLUE, msg);
			}
		} else
		//Team (again)
		if (str.startsWith("'"))
		{
			//Don't send " to pub chat
			if (str.length() > 1)
			{
				msg = str.substring(1);
				sendFreq(freq, msg);
				win.println(win.YELLOW, "T " + StrPad(name) +
					"> " + msg);
			}
		} else
		//Private (must be after team, because //)
		if (str.startsWith("/"))
		{
			String to = win.getSelectedName();
			if (to == null) return;

			msg = str.substring(1);
			sendPriv(to, msg);
			
			win.println(win.GREEN, "P " + StrPad(name) +
				"> " + msg);
		} else
		//Staff chat
		if (str.startsWith("\\"))
		{
			//Don't send "\" to pub chat
			if (str.length() > 1)
			{
				msg = str.substring(1);
				sendMod(msg);
				win.println(win.RED, "* " + StrPad(name) + "> "
					+ msg);
			}
		} else
		//Change freq
		if (str.startsWith("="))
		{
			if (str.length() > 1)
			{
				ChangeFreq(str.substring(1));
			}
		} else
		//Squad. Should be :#Squad:message
		if (str.startsWith("#"))
		{
			if (str.length() > 3)
			{
				part = str.substring(1).split(":", 2);
				sendSquad(part[0], part[1]);
				win.println(win.GREEN, "P :#" + part[0] + ":" +
					part[1]);
			}
		} else
		{
			sendPub(str);
			win.println(win.BLUE, "  " + StrPad(name) + "> " + str);
		}
	}

//// Receive ////

	public void msgHandler(String in)
	{
		String msg = in.toUpperCase();
		String[] part;
		String name, ignore;

		if (msg.startsWith("ARENA:"))
		{
			if (bGotSheep)
			{
				win.println("  " + in.substring(6));
			} else
			{
				bGotSheep = true;
				win.setSheep(in.substring(6));
			}
		} else
		if (msg.startsWith("PUB:"))
		{
			part = in.split(":", 3);
			ignore = pd.getFlags(part[1]);
			if (ignore == null || ignore.indexOf("I") < 0)
			{
				name = StrPad(part[1]);
				win.println(win.BLUE,
					"  " + name + "> " + part[2]);
			}
		} else
		if (msg.startsWith("PRIV:"))
		{
			part = in.split(":", 3);
			ignore = pd.getFlags(part[1]);
			if (ignore == null || ignore.indexOf("I") < 0)
			{
				lm.Log("D", "<core> Received: " + in);
				name = StrPad(part[1]);
				
				//billing.c 117 hack
				//remote priv
				if (part.length < 3)
				{
					int i = part[1].indexOf("> ");
					name = part[1].substring(0, i);
					win.println(win.GREEN, "P (" + name +
						")>" + part[1].substring(i+2));
					part[1] = name; //?away hack
				}
				else if (pd.existPlayer(part[1]))
				{
					//local
					win.println(win.GREEN,
						"P " + name + "> " + part[2]);
				}
				else
				{
					//revision 1.4
					//remote
					win.println(win.GREEN, "P (" + part[1] +
						")>" + part[2]);
				}
				
				//:: code
				win.addLastPrivPlayer(part[1]);
				
				//?away code
				if (awayMsg.length() > 0 &&
					!part[1].equals(lastAwayName))
				{
					sendPriv(part[1], awayMsg);
					win.println(win.GREEN, "P " +
						StrPad(this.name) + "> " +
						awayMsg);
					lastAwayName = part[1];
				}
			}
		} else
/* Not in protocol 1 revision 1.4
		if (msg.startsWith("REMOTEPRIV:"))
		{
			part = in.split(":", 3);
			ignore = pd.getFlags(part[1]);
			if (ignore == null || ignore.indexOf("I") < 0)
			{
				win.println(win.GREEN, "P (" + part[1] + ")>" +
					part[2]);

				//?away code
				if (awayMsg.length() > 0 &&
					!part[1].equals(lastAwayName))
				{
					sendPriv(part[1], awayMsg);
					win.println(win.GREEN, "P " +
						StrPad(this.name) + "> " +
						awayMsg);
					lastAwayName = part[1];
				}
			}
		} else
*/
		if (msg.startsWith("FREQ:"))
		{
			part = in.split(":", 3);
			ignore = pd.getFlags(part[1]);
			if (ignore == null || ignore.indexOf("I") < 0)
			{
				if (pd.getFreq(part[1]).equals(freq))
				{
					win.println(win.YELLOW, "T " +
						StrPad(part[1]) + "> " +
						part[2]);
				} else
				{
					win.println(win.GREEN, "E " +
						StrPad(part[1]) +
						"> ", win.BLUE, part[2]);
				}
			}
		} else
		if (msg.startsWith("CHAT:"))
		{
			win.println(win.ORANGE, "C " + in.substring(5));
		} else
		if (msg.startsWith("MOD:"))
		{
			part = in.split(":", 3);
			if (part[1].startsWith("cheater {") || part.length < 3)
			{
				win.println(win.RED, "* " + part[1]);
			} else
			{
				win.println(win.RED, "* " + part[1] + "> " +
					part[2]);
			}
		} else
		if (msg.startsWith("SYSOP:"))
		{
			win.println(win.RED, "? " + in.substring(6));
		} else
		if (msg.startsWith("SQUAD:"))
		{
			//SQUAD:squad:sender:msg
			part = in.split(":", 4);
			win.println(win.GREEN, "P (" + part[1] + ")(" + part[2]
				+ ")>" + part[3]);
		} else
		{
			lm.Log("M", "<core> Unhandled message: MSG:" +
				in);
		}
	}

	public void mainHandler(String in)
	{
		String msg = in.toUpperCase();
		String[] part;

		if (msg.startsWith("LOGINBAD:"))
		{
			lm.Log("E", "<core> Login failed: " +
				in.substring(9));
			win.println("  WARNING: Login failed (" +
				in.substring(9) + ")");
			disconnect();
		} else
		if (msg.startsWith("LOGINOK:"))
		{
			lm.Log("D", "<core> Login OK (" +
				in.substring(8) + ")");
			this.name = in.substring(8);
			sendRaw("GO:" + this.arena);

			if (auto != null && auto.length() > 1)
			{
				//This timer performs autocommands after ?sheep
				java.util.Timer timer = new java.util.Timer();
				timer.schedule(new autotimer(timer), 3000);
			} else lm.Log("D", "no auto commands");
		} else
		if (msg.startsWith("INARENA:"))
		{
			part = in.split(":", 3);
			lm.Log("I", "<core> Entered " + part[1] +
				" on " + part[2] + "Ghz");
			this.arena = part[1];
			this.freq  = part[2];
			pd.reset();
			win.playerReset();
			win.playerEntered(name, freq);
			
			//This timer sends ?sheep well after GreetMessage
			java.util.Timer timer = new java.util.Timer();
			timer.schedule(new sheeptimer(timer), 1250);
			//bGotSheep = false;
			//sendCmd("?sheep");
		} else
		if (msg.startsWith("PLAYER:"))
		{
			part = in.split(":", 4);
			pd.insPlayer(part[1], part[2], part[3]);
			win.playerEntered(part[1], part[3]);
		} else
		if (msg.startsWith("ENTERING:"))
		{
			part = in.split(":", 4);
			pd.insPlayer(part[1], part[2], part[3]);
			if (showEnterMsg == 0)
			{
				win.printStatus(part[1] +
					" entered arena");
			} else
			if (showEnterMsg == 1)
			{
				win.println("  " + part[1] +
					" entered arena");
			}
			win.playerEntered(part[1], part[3]);
		} else
		if (msg.startsWith("LEAVING:"))
		{
			part = in.split(":", 2);
			pd.rmPlayer(part[1]);
			if (showLeaveMsg == 0)
			{
				win.printStatus(part[1] +
					" left arena");
			} else
			if (showLeaveMsg == 1)
			{
				win.println("  " + part[1] +
					" left arena");
			}
			win.playerLeft(part[1]);

		} else
		if (msg.startsWith("SHIPFREQCHANGE:"))
		{
			part = in.split(":", 4);
			lm.Log("D", "<core> [" + part[1] + "] " +
				"Changed ship/freq to ship " +
				part[2] + ", freq " + part[3]);
			pd.rmPlayer(part[1]);
			pd.insPlayer(part[1], part[2], part[3]);
			
			if (part[1].equalsIgnoreCase(name))
				freq = part[3];
			win.playerFreqChange(part[1], part[3]);
		} else
		if (msg.startsWith("KILL:"))
		{
			//KILL:killer:killed:bounty:flags
			//name(bounty) killed by: name
			part = in.split(":", 5);
			String flags = "";
			if (!part[4].equals("0")) flags = ":" + part[4];
			if (showKillMsg == 0)
			{
				win.printStatus(part[2] +
					"(" + part[3] + flags + ") killed by: "
					+ part[1]);
			} else
			if (showKillMsg == 1)
			{
				win.println("  " + part[2] +
					"(" + part[3] + flags + ") killed by: "
					+ part[1]);
			}	
		} else
		if (msg.startsWith("MSG:"))
		{
			msgHandler(in.substring(4));
		} else
		{
			lm.Log("M", "<core> Unhandled message: " + in);
		}
		
		//Life sign indicator
		win.updateTime();
	}

//// Core ////

	public core(loggers lm, config cfg, ui win, data pd)
	{
		this.lm  = lm;
		this.cfg = cfg;
		this.win = win;
		this.pd  = pd;
		win.setCore(this);
	}

	public void connect(String address, int port,
		String name, String pass,
		String arena, String auto)
	{
		this.name  = name;
		this.pass  = pass;
		this.arena = arena;
		this.auto  = auto;
		
		lm.Log("I", "<core> Connecting to " + address + " on " + port);

		try {
			socket = new Socket(address, port);
			send = new PrintWriter(
				socket.getOutputStream(), true);
			recv = new BufferedReader(
				new InputStreamReader(
				socket.getInputStream()));

			socket.setKeepAlive(true);
			//socket.setSoLinger(true, 2);
			socket.setSoTimeout(20000); //20 seconds

			bConnected = bKeepGoing = true;
			this.start();
		}
		catch (UnknownHostException e)
		{
			lm.Log("E", "<core> Unknown host");
			win.println("  WARNING: " + e.getMessage() +
				" (unknown host)");
			if (bConnected) disconnect();
		}
		catch (NoRouteToHostException e)
		{
			lm.Log("E", "<core> " + e.getMessage());
			win.println("  WARNING: " + e.getMessage() + " (no route)");
			if (bConnected) disconnect();
		}
		catch (ConnectException e)
		{
			lm.Log("E", "<core> " + e.getMessage());
			win.println("  WARNING: " + e.getMessage() + " (TCP)");
			if (bConnected) disconnect();
		}
		catch (Exception e)
		{
			lm.Log("E", "<core> " + e.getMessage());
			e.printStackTrace();
		}
	}

	private void receive()
	{
		try
		{
			mainHandler( recv.readLine() );
		}
		catch(SocketTimeoutException e)
		{
			/* Ignore */
		}
		catch(NullPointerException e)
		{
			lm.Log("D", "<core> null socket/disconnected");
			if (bConnected)
				disconnect();
			stage = STAGE_STOPPED;
		}
		catch(SocketException e)
		{
			lm.Log("D", "<core> socket closed/disconnected");
			if (bConnected)
				disconnect();
			stage = STAGE_STOPPED;
		}
		catch(Exception e)
		{
			lm.Log("E", "<core> Receive error: " +
				e.getMessage());
			e.printStackTrace();
		}
	}

	public void run()
	{
		long nextKeepAlive = System.currentTimeMillis() + 180 * 1000;
		
		Login();
		win.show();
		
		while(bKeepGoing)
		{
			try
			{
				Thread.sleep( 350 ); //0.35 second
			}
			catch(InterruptedException e)
			{
				lm.Log("E", "<core> " +
					e.getMessage());
			}
			catch(Exception e)
			{
				lm.Log("E", "<core> " +
					e.getMessage());
				e.printStackTrace();
			}

			if (bConnected)
			{
				receive();
				
				if (System.currentTimeMillis() > nextKeepAlive)
				{
					sendRaw("NOOP");
					nextKeepAlive =
						System.currentTimeMillis()
						+ 180 * 1000;
				}
			}
		}
	}

	public void disconnect()
	{
		try
		{
			bKeepGoing = false;
			this.interrupt();

			socket.shutdownInput();
			socket.shutdownOutput();
			send.close();
			recv.close();
			//socket.getOutputStream().close();
			//socket.getInputStream().close();
			socket.close();
			bConnected = false;
		}
		catch(NullPointerException e)
		{
			e.printStackTrace();
			//If it couldn't make the socket then send, recv
			// and socket are probably null
		}
		catch(SocketException e)
		{
			lm.Log("D", "<core> " + e.getMessage());
		}
		catch(Exception e)
		{
			lm.Log("E", "<core> " + e.getMessage());
			e.printStackTrace();
		}
		win.println("  WARNING: Disconnected from server");
	}

	class autotimer extends java.util.TimerTask
	{
		java.util.Timer t;

		public autotimer(java.util.Timer t)
		{
			this.t = t;
		}

		public void run()
		{
			//String auto = cfg.GetStr("ChatNet", "Auto");
			//Won't except | or \, bah
			String[] part = auto.split(":", 8); 
			for(int i=0; i<part.length; i++)
			{
				//sendCmd(part[i].trim());
				cmdHandler(part[i].trim());
			}
			
			t.cancel();
		}
	}

	class sheeptimer extends java.util.TimerTask
	{
		java.util.Timer t;

		public sheeptimer(java.util.Timer t)
		{
			this.t = t;
		}

		public void run()
		{
			bGotSheep = false;
			sendCmd("?sheep");
			
			t.cancel();
		}
	}
}
